#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

int main (int argc, char *argv[]) {

  int fd;

  if (argc!= 2) {
    printf("Syntax: write_on_file <file_name>\n");
    exit(EXIT_FAILURE);
  }

  fd=open(argv[1], O_CREAT| O_TRUNC|O_WRONLY,S_IRUSR|S_IWUSR);

  if (fd == -1) {
    perror("Open error: ");
    exit(EXIT_FAILURE);
  }
  printf("------------------------------------------------\n");
  printf("File access allowed through descriptor fd = %d\n",fd);
  printf("Applying redirection of standard output\n");
  printf("------------------------------------------------\n");
  fflush(stdout);

  if (close (1) == -1) {
    perror("Close error: ");
    exit(EXIT_FAILURE);
  };


  if ((fd = dup(fd)) == -1) {
    perror("Dup error: ");
    exit(EXIT_FAILURE);
  };

  execve("./writer", NULL, NULL);
  perror("Exec error: ");
  exit(EXIT_FAILURE);
}

