#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include "mini-tar.h"


header tar_head;

file_info * the_files;

int files_to_manage;

int main(int argc, char *argv[]) { 
	int dd, size, result; 
	int i;
	off_t seek;
	off_t file_start, file_end;
	char c;

	 if (argc < 3) { /* check the number of arguments */ 

		printf("usage: extract archive file\n");
		return EXIT_FAILURE;
	 }  


	 /* archive opening */
	 dd=open(argv[1],O_RDONLY); 
	 if (dd == -1) {
		printf("archive open error\n");
		fflush(stdout);
	        return EXIT_FAILURE;
	 }

	result = read(dd,&tar_head,sizeof(header));

	if (result != sizeof(tar_head)){
	   printf("unable to read the mini-tar header (file is %s)\n",argv[1]);
	   fflush(stdout);
	   return EXIT_FAILURE;
	}

	files_to_manage = tar_head.num_files;

	the_files = (file_info*)malloc(files_to_manage*sizeof(file_info));

	result = read(dd,the_files,files_to_manage*sizeof(file_info));
	if(result != (files_to_manage*sizeof(file_info))){
		printf("mini-tar file read error\n");
		fflush(stdout);
		return EXIT_FAILURE;
	}

	for (i=0;i<files_to_manage;i++){

	  if(strcmp(argv[2], the_files[i].file_name)==0){
	    printf("File %s - found in the archive\n",argv[2]);
	    fflush(stdout);
	    file_start = the_files[i].start_position;
	    file_end = the_files[i].end_position;
	    printf("File %s - found in the archive - position is [%d,%d]\n",argv[2],file_start,file_end);
	 
	    seek = lseek(dd,file_start,SEEK_SET);

	    printf("seek position for file %s is %d\n",argv[2],seek);
	    fflush(stdout);

	//HOMEWORK - please optimize here and put the possibility to extract to a file rather than stdout
	    for(;seek<file_end;seek++){
		read(dd,&c,1);
		write(1,&c,1);

	    }

	   return 0;
	  }	
	}

	printf("file %s not found in the mini-tar\n",argv[2]);
	fflush(stdout);

  }/* end main*/

